 /*
 *  file      : split_spectre.c
 *  project   : xcfa
 *  with      : Gtk-2
 *
 *  copyright : (C) 2003 - 2013 by Claude Bulin
 *
 *  xcfa - GTK+ implementation of the GNU shell command
 *  GNU General Public License
 *
 *  This file is part of XCFA.
 * 
 *  XCFA is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  at your option) any later version.
 * 
 *  XCFA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with XCFA.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#include <gtk/gtk.h>
#include <math.h>
#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib/lib.h"
#endif

#include "global.h"
#include "get_info.h"
#include "tags.h"
#include "split.h"




#define	SAMPLE_SHADES	3

extern VAR_SPLIT VarSplit;
extern ADJUST Adjust;


gint	MarkerOld = -1;


// 
// 
gint SplitSpectre_get_with (void)
{
	return( VarSplit.AdrWidgetSpectre->allocation.width * Adjust.mul );
	/*
	if( 1 == Adjust.mul )
		return( VarSplit.AdrWidgetSpectre->allocation.width * Adjust.mul );
	return( VarSplit.MaxPointsInTab * Adjust.mul );
	*/
}
// AFFICHAGE IMAGE CHRONO
// 
void SplitSpectre_draw_chrono ( GtkWidget *widget )
{
	GdkColor		gdk_color;
	GdkColormap		*colormap;
	GdkGC			*gc;
	GdkPoint		poly [ 10 ];
	PangoContext		*p_context = NULL;
	PangoLayout		*layout = NULL;
	PangoFontDescription	*fontdesc;
	gint			layoutX = 0;
	gint			layoutY = 0;
	gint			CursorX, CursorY;
	GdkModifierType		state;
	gint			ChronoX;
	
	gint			sec;
	// gdouble			dsec;
	gdouble			TimeSongSec;
	gdouble			Percent;
	gint			H, M, S;
	gchar			*Str = NULL;
	// gint			hundr;
	// gint			C;
	
	/*
	cairo_t		*cr;
	
	if (NULL == widget) return;
	
	cr = gdk_cairo_create( widget->window );
	cairo_scale( cr, 1.0, 1.0 );
	cairo_translate( cr, 0.0, 0.0 );
	
	// COLOR: 0 .. 255 -> PRG: colorname
	gdouble	red, blue, green;
		
	// CLEAR  PREVIEW SURFACE
	// CRAYON_GRIS
	red   = 99
	blue  = 99
	green = 99
	cairo_set_source_rgb( cr, red/255.0, green/255.0, blue/255.0 );
	cairo_rectangle( cr,
			 0,
			 0,
			 widget ->allocation.width,
			 widget->allocation.height
			 );			
	cairo_fill( cr );
	
	// ECRITURE BARRE CHRONOLOGIQUE
	// CRAYON_BLANC
	red   = 255
	blue  = 255
	green = 255
	cairo_set_source_rgb( cr, red/255.0, green/255.0, blue/255.0 );
	
#define  SPLIT_TIME_CHRONO_   80
	for (ChronoX = 2; ChronoX +60 <= VARSPLIT_CHRONO_W +80; ChronoX += SPLIT_TIME_CHRONO_) {
		if (ChronoX > 2) {
			gdk_draw_line (
				widget->window,
				gc,
				ChronoX -2,
				VARSPLIT_CHRONO_Y,
				ChronoX -2,
				VARSPLIT_CHRONO_Y + VARSPLIT_CHRONO_H
				);
		}
	}
	
	
	cairo_paint( cr );
	*/
	
	if (NULL == widget) return;

	colormap = gdk_drawable_get_colormap (widget->window);
	gc = gdk_gc_new (widget->window);
	
	// CLEAR
	poly [ 0 ] . x = VARSPLIT_CHRONO_X;
	poly [ 0 ] . y = VARSPLIT_CHRONO_Y;
	poly [ 1 ] . x = VARSPLIT_CHRONO_X + VARSPLIT_CHRONO_W +1;
	poly [ 1 ] . y = VARSPLIT_CHRONO_Y;
	poly [ 2 ] . x = VARSPLIT_CHRONO_X + VARSPLIT_CHRONO_W +1;
	poly [ 2 ] . y = VARSPLIT_CHRONO_Y + VARSPLIT_CHRONO_H +1;
	poly [ 3 ] . x = VARSPLIT_CHRONO_Y;
	poly [ 3 ] . y = VARSPLIT_CHRONO_Y + VARSPLIT_CHRONO_H +1;
	poly [ 4 ] . x = VARSPLIT_CHRONO_X;
	poly [ 4 ] . y = VARSPLIT_CHRONO_Y;
	
	CRAYON_GRIS
	gdk_draw_polygon (
		widget->window,
		gc,
		TRUE,
		poly,
		4
		);
#define  SPLIT_TIME_CHRONO_   80
	// ECRITURE BARRE CHRONOLOGIQUE
	CRAYON_BLANC
	for (ChronoX = 2; ChronoX +60 <= VARSPLIT_CHRONO_W +80; ChronoX += SPLIT_TIME_CHRONO_) {
		if (ChronoX > 2) {
			gdk_draw_line (
				widget->window,
				gc,
				ChronoX -2,
				VARSPLIT_CHRONO_Y,
				ChronoX -2,
				VARSPLIT_CHRONO_Y + VARSPLIT_CHRONO_H
				);
		}
		p_context = gtk_widget_get_pango_context (widget);
		layout = pango_layout_new (p_context);
		fontdesc = pango_font_description_from_string ("Times New Roman 8");
		pango_layout_set_font_description (layout, fontdesc);
		layoutX = ChronoX;
		layoutY = VARSPLIT_CHRONO_Y + 3;

		CursorX = (gint)VarSplit.AdjScroll->value;
		CursorX += ChronoX;
		CursorX -= 2;
		
		if (NULL != VarSplit.Tags) {
			TimeSongSec = VarSplit.Tags->SecTime;
		}
		else {
			TimeSongSec = 300;
		}
		Percent = ((gdouble)CursorX / (gdouble)SplitSpectre_get_with() ) * 100.0;
		sec = (gint) (((gdouble)TimeSongSec * (gdouble)Percent) / 100.0);
		// dsec  = ((gdouble)TimeSongSec *(gdouble)Percent) / 100.0;
		// hundr = ((gdouble)dsec - (gdouble)sec) * 100.0;
		H = (sec / 60) / 60;
		M = (sec / 60) % 60;
		S = sec % 60;
		// C = hundr;
		Str = g_strdup_printf ("%02d:%02d:%02d", H, M, S);

		pango_layout_set_markup (layout, Str, -1);
		gdk_draw_layout (
			widget->window,
			gc,
			layoutX,
			layoutY,
			layout
			);
		g_object_unref (layout);
		g_free (Str);
		Str = NULL;
	}
	
	gdk_window_get_pointer (widget->window, &CursorX, &CursorY, &state);
	if (CursorX < VARSPLIT_CHRONO_X)
		CursorX = VARSPLIT_CHRONO_X;
	else if (CursorX > (VARSPLIT_CHRONO_X + VARSPLIT_CHRONO_W) -1)
		CursorX = VARSPLIT_CHRONO_X + VARSPLIT_CHRONO_W;
	
	if (CursorY < VARSPLIT_CHRONO_Y)
		CursorY = VARSPLIT_CHRONO_Y;
	else if (CursorY > (VARSPLIT_CHRONO_Y + VARSPLIT_CHRONO_H) -1)
		CursorY = VARSPLIT_CHRONO_Y + VARSPLIT_CHRONO_H;
	
	// REPAIR VERTICAL PARTIE HAUTE
	if (VarSplit.NbrSelecteurs > 0) {
		CRAYON_ROUGE
		gdk_draw_line (
			widget->window,
			gc,
			CursorX,
			VARSPLIT_CHRONO_Y,
			CursorX,
			VARSPLIT_CHRONO_Y + VARSPLIT_CHRONO_H
			);
	}
	gdk_gc_destroy (gc);
	
	// POSITION DU CURSEUR DANS LA FORME D ONDE
	/*
	if (NULL != VarSplit.Tags) {
		TimeSongSec = VarSplit.Tags->SecTime;
	}
	else {
		TimeSongSec = 300;
	}
	CursorX += (gint)Adj->value;
	Percent = ((gdouble)CursorX / (gdouble)VarSplit.AdrWidgetSpectre->allocation.width) * 100.0;
	sec = (gint) (((gdouble)TimeSongSec * (gdouble)Percent) / 100.0);
	dsec  = ((gdouble)TimeSongSec *(gdouble)Percent) / 100.0;
	hundr = ((gdouble)dsec - (gdouble)sec) * 100.0;
	H = (sec / 60) / 60;
	M = (sec / 60) % 60;
	S = sec % 60;
	C = hundr;
	gtk_label_set_use_markup (GTK_LABEL(GLADE_GET_OBJECT("label_temps_actuel_curseur_split")), TRUE);
	if (VarSplit.NbrSelecteurs > 0) {
		// Str = g_strdup_printf ("<b>Codage en cours ...</b>\n%02d:%02d:%02d.%02d", H, M, S, C);
		Str = g_strdup_printf ("<b>Codage en cours ...</b>\n%02d:%02d:%02d", H, M, S);
	}
	else {
		// Str = g_strdup ("<b>Codage en cours ...</b>\n00:00:00.00");
		Str = g_strdup ("<b>Codage en cours ...</b>\n00:00:00");
	}
	gtk_label_set_markup (GTK_LABEL(GLADE_GET_OBJECT("label_temps_actuel_curseur_split")), Str);
	// g_print("%s\n", Str);
	g_free (Str);
	Str = NULL;
	*/
}
// AFFICHAGE IMAGE TOP
// 
void SplitSpectre_draw_top ( GtkWidget *widget )
{
	GdkColor		gdk_color;
	GdkColormap		*colormap;
	GdkGC			*gc;
	GdkPoint		poly [ 10 ];
	
	if (NULL == widget) return;
	
	colormap = gdk_drawable_get_colormap (widget->window);
	gc = gdk_gc_new (widget->window);
	
	// CLEAR
	poly [ 0 ] . x = VARSPLIT_SPECTRE_TOP_X;
	poly [ 0 ] . y = VARSPLIT_SPECTRE_TOP_Y;
	poly [ 1 ] . x = VARSPLIT_SPECTRE_TOP_X + VARSPLIT_SPECTRE_TOP_W +1;
	poly [ 1 ] . y = VARSPLIT_SPECTRE_TOP_Y;
	poly [ 2 ] . x = VARSPLIT_SPECTRE_TOP_X + VARSPLIT_SPECTRE_TOP_W +1;
	poly [ 2 ] . y = VARSPLIT_SPECTRE_TOP_Y + VARSPLIT_SPECTRE_TOP_H +1;
	poly [ 3 ] . x = VARSPLIT_SPECTRE_TOP_Y;
	poly [ 3 ] . y = VARSPLIT_SPECTRE_TOP_Y + VARSPLIT_SPECTRE_TOP_H +1;
	poly [ 4 ] . x = VARSPLIT_SPECTRE_TOP_X;
	poly [ 4 ] . y = VARSPLIT_SPECTRE_TOP_Y;
	
	CRAYON_GRIS_CLAIR
	gdk_draw_polygon (
		widget->window,
		gc,
		TRUE,
		poly,
		4
		);
				
	if (VarSplit.NbrSelecteurs > 0) {
		
		gint			begin = 0;
		gint			Len;
		gint			SelBegin;
		gint			SelEnd;
		gint			Cpt;
		gint			i;
		PangoContext		*p_context = NULL;
		PangoLayout		*layout = NULL;
		PangoFontDescription 	*fontdesc;
		gint			layoutX = 0;
		gint			layoutY = 0;
		gchar			*Str = NULL;
		
		// PRINT_FUNC_LF();
		begin = (gint)VarSplit.AdjScroll->value;
		Len = SplitSpectre_get_with () + begin;
		
		// DRAW ALL SELECTEURS
		for (Cpt = 0; Cpt < MAX_SELECTEURS_SPLIT; Cpt ++) {
								
			// if (Cpt == VarSplit.SelecteurActif) continue;
			if (VarSplit.Selecteur [ Cpt ] . Nmr == -1) break;
			
			// FLECHE LIGNE DEBUT
			SelBegin = SplitSelector_get_pos_begin (Cpt);
			if (SelBegin >= begin && SelBegin <= Len) {
				
				poly [ 0 ] . x = SelBegin;
				CRAYON_NOIR
				for (i = 0; i < 9; i++) {
					gdk_draw_line (widget->window,
							gc,
							SelBegin - begin + i,
							(VARSPLIT_SPECTRE_TOP_Y + 1) + i,
							SelBegin - begin + i,
							(VARSPLIT_SPECTRE_TOP_Y + 16) - i
							);
				}
				
				p_context = gtk_widget_get_pango_context (widget);
				layout = pango_layout_new (p_context);
				fontdesc = pango_font_description_from_string ("Times New Roman 9");
				pango_layout_set_font_description (layout, fontdesc);
				Str = g_strdup_printf("%d", Cpt +1);
				layoutX = poly [ 0 ] . x + 10;
				layoutY = VARSPLIT_SPECTRE_TOP_Y +2;
				pango_layout_set_markup (layout, Str, -1);
				CRAYON_NOIR
				gdk_draw_layout (
					widget->window,
					gc,
					layoutX - begin,
					layoutY,
					layout
					);
				g_free (Str);
				Str = NULL;
				g_object_unref (layout);
			}
			
			// FLECHE LIGNE FIN
			SelEnd = SplitSelector_get_pos_end (Cpt);
			if (SelEnd > SelBegin && SelEnd > begin && SelEnd < Len) {
				
				poly [ 0 ] . x = SelEnd;
				CRAYON_NOIR
				for (i = 0; i < 9; i++) {
					gdk_draw_line (widget->window,
							gc,
							SelEnd - begin - i,
							(VARSPLIT_SPECTRE_TOP_Y + 1) + i,
							SelEnd - begin - i,
							(VARSPLIT_SPECTRE_TOP_Y + 16) - i
							);
				}
				
				p_context = gtk_widget_get_pango_context (widget);
				layout = pango_layout_new (p_context);
				fontdesc = pango_font_description_from_string ("Times New Roman 9");
				pango_layout_set_font_description (layout, fontdesc);
				Str = g_strdup_printf("%d", Cpt +1);
				if (Cpt +1 < 10)
					layoutX = poly [ 0 ] . x - 16;
				else	layoutX = poly [ 0 ] . x - 21;
				layoutY = VARSPLIT_SPECTRE_TOP_Y +2;
				pango_layout_set_markup (layout, Str, -1);
				CRAYON_NOIR
				gdk_draw_layout (
					widget->window,
					gc,
					layoutX - begin,
					layoutY,
					layout
					);
				g_free (Str);
				Str = NULL;
				g_object_unref (layout);
			}
		}
		
		// DRAW SELECTEUR ACTIF
		// FLECHE LIGNE DEBUT
		SelBegin = SplitSelector_get_pos_begin (VarSplit.SelecteurActif);
		if (SelBegin >= begin && SelBegin < Len) {
			poly [ 0 ] . x = SelBegin;
			// 
			CRAYON_ORANGE
			for (i = 0; i < 9; i++) {
				gdk_draw_line (widget->window,
						gc,
						SelBegin - begin + i,
						(VARSPLIT_SPECTRE_TOP_Y + 1) + i,
						SelBegin - begin + i,
						(VARSPLIT_SPECTRE_TOP_Y + 16) - i
						);
			}
			p_context = gtk_widget_get_pango_context (widget);
			layout = pango_layout_new (p_context);
			fontdesc = pango_font_description_from_string ("Times New Roman 9");
			pango_layout_set_font_description (layout, fontdesc);
			Str = g_strdup_printf("%d", VarSplit.SelecteurActif +1);
			layoutX = poly [ 0 ] . x + 10;
			layoutY = VARSPLIT_SPECTRE_TOP_Y +2;
			pango_layout_set_markup (layout, Str, -1);
			CRAYON_BLANC
			gdk_draw_layout (
				widget->window,
				gc,
				layoutX - begin,
				layoutY,
				layout
				);
			g_free (Str);
			Str = NULL;
			g_object_unref (layout);
		}
		
		// FLECHE LIGNE FIN
		SelEnd = SplitSelector_get_pos_end (VarSplit.SelecteurActif);	
		if (SelEnd >= begin && SelEnd < Len) {
			if (VarSplit.SelecteurActif == VarSplit.NbrSelecteurs -1) SelEnd --;
			poly [ 0 ] . x = SelEnd;
			// 
			CRAYON_VERT
			for (i = 0; i < 9; i++) {
				gdk_draw_line (widget->window,
						gc,
						SelEnd - begin - i,
						(VARSPLIT_SPECTRE_TOP_Y + 1) + i,
						SelEnd - begin - i,
						(VARSPLIT_SPECTRE_TOP_Y + 16) - i
						);
				}
			p_context = gtk_widget_get_pango_context (widget);
			layout = pango_layout_new (p_context);
			fontdesc = pango_font_description_from_string ("Times New Roman 9");
			pango_layout_set_font_description (layout, fontdesc);
			Str = g_strdup_printf("%d", VarSplit.SelecteurActif +1);
			if (VarSplit.SelecteurActif +1 < 10)
				layoutX = poly [ 0 ] . x - 16;
			else	layoutX = poly [ 0 ] . x - 21;
			layoutY = VARSPLIT_SPECTRE_TOP_Y +2;
			pango_layout_set_markup (layout, Str, -1);
			CRAYON_BLANC
			gdk_draw_layout (
				widget->window,
				gc,
				layoutX - begin,
				layoutY,
				layout
				);
			g_free (Str);
			Str = NULL;
			g_object_unref (layout);
		}
	}
	gdk_gc_destroy (gc);
}
// 
// 
void SplitSpectre_remove_draw (void)
{
	if (NULL != VarSplit.MaxScale_0) {	g_free (VarSplit.MaxScale_0);		VarSplit.MaxScale_0 = NULL; }
	if (NULL != VarSplit.MinScale_0) {	g_free (VarSplit.MinScale_0);		VarSplit.MinScale_0 = NULL; }
	if (NULL != VarSplit.MaxScale_1) {	g_free (VarSplit.MaxScale_1);		VarSplit.MaxScale_1 = NULL; }
	if (NULL != VarSplit.MinScale_1) {	g_free (VarSplit.MinScale_1);		VarSplit.MinScale_1 = NULL; }
	if (NULL != VarSplit.MaxScale_2) {	g_free (VarSplit.MaxScale_2);		VarSplit.MaxScale_2 = NULL; }
	if (NULL != VarSplit.MinScale_2) {	g_free (VarSplit.MinScale_2);		VarSplit.MinScale_2 = NULL; }
}
// 
// 
void SplitSpectre_remove (void)
{
	if (NULL != VarSplit.Tab) {	g_free (VarSplit.Tab);	VarSplit.Tab = NULL; }
	SplitSpectre_remove_draw ();
	VarSplit.Tags = tagswav_remove_info (VarSplit.Tags);
}
// 
// PERCENT = ( VALUE_X / LONGUEUR_TOTALE ) * 100.0
// VALUE_X = ( LONGUEUR_TOTALE * PERCENT ) / 100.0
// 
// xavier a écrit : 
// Le marqueur de début doit coller le début de la forme d'onde. Celui de fin à la fin de la forme d'onde
// 
// From @Dzef:
// 	Sinon, Claude, pour le soucis de not'
// 	Christophe-coupeur-d'album-en-rondelles-sans-cue, la parade existe en partie
// 	dans le cas où les plages sont séparées par des "blancs" (ce qui n'est pas
// 	le cas des albums "live" par exemple) : il suffit de détecter le niveau
// 	audio et en dessous d'un seuil fixé (typiquement < ~-50 dB), hop, 1 plage !
// 	C'est peut être une option (un bouton) à cogiter pour une future mouture,
// 	non ? M'est avis qu'not' Christophe serait pas contre...					
// 
// PS:
// 	Et chose fut faite: MERCI Xavier  :-)
// 
void SplitSpectre_search_blank_pass (void)
{
	gint		IndicePoints = -1;
	gint		PointBegin = -1;
	gint		PointEnd = -1;
	gint		Indice;
	gdouble		PercentBegin;
	gdouble		PercentEnd;
	gint		ValueBegin;
	gint		ValueEnd;
	gint		MaxPoints = VarSplit.MaxPointsInTab;
	gboolean	BoolErr = FALSE;
	
	if (TRUE == VarSplit.BoolBlankWithCue) {
		PRINT("TRUE == VarSplit.BoolBlankWithCue");
		return;
	}
	
	PRINT_FUNC_LF();
	
	Indice = 0;
	do {
		if (VarSplit.Tab [ Indice ].Min == 0 && VarSplit.Tab [ Indice ].Max == 0) {
			
			if (-1 == PointBegin) {
				while (Indice < MaxPoints && VarSplit.Tab [ Indice ].Min == 0 && VarSplit.Tab [ Indice ].Max == 0) Indice ++;
				PointBegin = Indice;
				while (Indice < MaxPoints && (VarSplit.Tab [ Indice ].Min != 0 || VarSplit.Tab [ Indice ].Max != 0)) Indice ++;
				PointEnd = Indice;
				if (PointBegin > -1 && PointEnd - PointBegin > 13) {
					
					IndicePoints ++;
					if( TRUE == OptionsCommandLine.BoolVerboseMode )
						g_print ("PointBegin = %6d   PointEnd = %6d   Diff = %6d\n", PointBegin, PointEnd, PointEnd - PointBegin);
					
					PercentBegin = ((gdouble)PointBegin / (gdouble)MaxPoints) * 100.0;
					ValueBegin = ((gdouble)SplitSpectre_get_with() * (gdouble)PercentBegin) / 100.0;
					
					PercentEnd = ((gdouble)PointEnd / (gdouble)MaxPoints) * 100.0;
					ValueEnd = ((gdouble)SplitSpectre_get_with() * (gdouble)PercentEnd) / 100.0;
										
					VarSplit.Selecteur [ IndicePoints ] . Nmr          = IndicePoints;
					VarSplit.Selecteur [ IndicePoints ] . BeginPaint   = ValueBegin;
					VarSplit.Selecteur [ IndicePoints ] . PercentBegin = PercentBegin;
					VarSplit.Selecteur [ IndicePoints ] . EndPaint     = ValueEnd;
					VarSplit.Selecteur [ IndicePoints ] . PercentEnd   = PercentEnd;
				}
				PointBegin = -1;
				PointEnd = -1;
			}
		}
		Indice ++;
	} while (Indice < MaxPoints);
	
	if (-1 == IndicePoints) {
		IndicePoints = 0;
		VarSplit.Selecteur [ IndicePoints ] . Nmr          = IndicePoints;
		PercentEnd = ((gdouble)(MaxPoints - 1) / (gdouble)MaxPoints) * 100.0;
		ValueEnd = ((gdouble)SplitSpectre_get_with() * (gdouble)PercentEnd) / 100.0;
		VarSplit.Selecteur [ 0 ] . PercentEnd = PercentEnd;
		VarSplit.Selecteur [ 0 ] . EndPaint   = ValueEnd;
	}
	
	if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
		g_print ("\n");
		g_print ("IndicePoints = [ 0 .. %d ]\n", IndicePoints);
		g_print ("\n");
	}
	
	// DEBUT
	Indice = 0;
	while (Indice < MaxPoints && VarSplit.Tab [ Indice ].Min == 0 && VarSplit.Tab [ Indice ].Max == 0) Indice ++;
	PercentBegin = ((gdouble)Indice / (gdouble)MaxPoints) * 100.0;
	ValueBegin = ((gdouble)SplitSpectre_get_with() * (gdouble)PercentBegin) / 100.0;
	VarSplit.Selecteur [ 0 ] . PercentBegin = PercentBegin;
	VarSplit.Selecteur [ 0 ] . BeginPaint   = ValueBegin;
	
	// VERIFIE QUE LES POINTS NE SE CHEVAUCHENT PAS
	BoolErr = FALSE;
	for (IndicePoints = 0; VarSplit.Selecteur [ IndicePoints ] . Nmr != -1; IndicePoints ++) {
		if (IndicePoints > 0) {
			// if ((gint)VarSplit.Selecteur [ IndicePoints -1 ] . End >= (gint)VarSplit.Selecteur [ IndicePoints ] . Begin) {
				// g_print ("[ %02d ] ERREUR entre End %d et Begin %d  -->  RECTIFICATION\n", IndicePoints, IndicePoints -1, IndicePoints);
				// BoolErr = TRUE;
				// break;
			// }
			if ((gint)VarSplit.Selecteur [ IndicePoints ] . BeginPaint >= (gint)VarSplit.Selecteur [ IndicePoints ] . EndPaint) {
				if( TRUE == OptionsCommandLine.BoolVerboseMode )
					g_print ("[ %02d ]ERREUR entre Begin %d et End %d  -->  RECTIFICATION\n", IndicePoints, IndicePoints, IndicePoints);
				BoolErr = TRUE;
				break;
			}
		}
	}
	
	// VERIFICATION DE LA COHERENCE DU TEMPS ENTRE DEUX POINTS BEGIN et END
	if (FALSE == BoolErr) {
		for (IndicePoints = 0; VarSplit.Selecteur [ IndicePoints ] . Nmr != -1; IndicePoints ++) {
			if (SplitSelector_get_diff_sec (VarSplit.Selecteur [ IndicePoints ] . PercentBegin, VarSplit.Selecteur [ IndicePoints ] . PercentEnd) <= 5) {
				if( TRUE == OptionsCommandLine.BoolVerboseMode )
					g_print ("ERREUR Temps < a 5 secondes entre BEGIN %d et END %d  -->  RECTIFICATION\n", IndicePoints, IndicePoints);
				BoolErr = TRUE;
				break;
			}
		}
	}
	
	if (TRUE == BoolErr) {
		for (IndicePoints = 1; IndicePoints < MAX_SELECTEURS_SPLIT; IndicePoints ++) {
			VarSplit.Selecteur [ IndicePoints ] . Nmr = -1;
			VarSplit.Selecteur [ IndicePoints ] . BeginPaint = -1;
			VarSplit.Selecteur [ IndicePoints ] . EndPaint = -1;
			VarSplit.Selecteur [ IndicePoints ] . PercentBegin =
			VarSplit.Selecteur [ IndicePoints ] . PercentEnd = 0.0;
		}
		IndicePoints = 0;
		VarSplit.Selecteur [ IndicePoints ] . Nmr          = IndicePoints;
		PercentEnd = ((gdouble)(MaxPoints - 1) / (gdouble)MaxPoints) * 100.0;
		ValueEnd = ((gdouble)SplitSpectre_get_with() * (gdouble)PercentEnd) / 100.0;
		VarSplit.Selecteur [ 0 ] . PercentEnd = PercentEnd;
		VarSplit.Selecteur [ 0 ] . EndPaint   = ValueEnd;
	}
	
	// PRINT CONSOLE
	if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
		for (IndicePoints = 0; VarSplit.Selecteur [ IndicePoints ] . Nmr != -1; IndicePoints ++) {
			g_print ("[ %2d ]   BEGIN = %5d  END = %5d  PERCENTBEGIN = %f  PERCENTEND = %f\n",
				VarSplit.Selecteur [ IndicePoints ] . Nmr,
				(gint)VarSplit.Selecteur [ IndicePoints ] . BeginPaint,
				(gint)VarSplit.Selecteur [ IndicePoints ] . EndPaint,
				VarSplit.Selecteur [ IndicePoints ] . PercentBegin,
				VarSplit.Selecteur [ IndicePoints ] . PercentEnd
				);
		}
		g_print ("\n");
	}
}
// LECTURE FICHIER
//
gboolean SplitSpectre_read_file_spectre (gchar *PathNameFile)
{
	FILE		*pFile = NULL;
	gboolean	found = FALSE;
	gint		Ret;
	gint		Indice;
	gint		ChannelNext;
	gint		min, max;
	gint		tmp = 0;
	gint		points;
	unsigned char	devbuf[ BLOCK_SIZE +10 ];
	WAVE		WaveHeader;
	TYPE_FILE_IS	TypeFileIs = FILE_IS_NONE;

	PRINT_FUNC_LF();
	if( TRUE == OptionsCommandLine.BoolVerboseMode )
		g_print("\t%s\n\n", PathNameFile);
	
	VarSplit.MaxPointsInTab = 0;
	VarSplit.TypeFileIs = FILE_IS_NONE;
	if (FILE_IS_WAV != (TypeFileIs = GetInfo_file_is (PathNameFile))) {
		
		// 
		SplitSpectre_remove_draw ();
		
		// DEL ALLOC MEMORY
		if (NULL != VarSplit.Tab) {
			g_free (VarSplit.Tab);	VarSplit.Tab = NULL;
			return (TRUE);
		}
	}
	
	if (FALSE == tagswav_read_file (PathNameFile, &WaveHeader)) {
		tagswav_close_file (&WaveHeader);
		if( TRUE == OptionsCommandLine.BoolVerboseMode )
			printf ("\nImpossible d'ouvrir le fichier : \"%s\"\n\n", PathNameFile);
		return FALSE;
	}
	pFile = WaveHeader.file;
	WaveHeader.file = NULL;
	
	if (pFile == NULL) {
		PRINT_FUNC_LF();
		if( TRUE == OptionsCommandLine.BoolVerboseMode )
			g_print ("\nImpossible d'ouvrir le fichier : \"%s\"\n\n", PathNameFile);
		return FALSE;
	}
	VarSplit.nBitsPerSample = WaveHeader.FMT.BitsPerSample;
	
	switch (WaveHeader.FMT.BitsPerSample) {
	case 8 :
	case 16 :
	case 24 :
	case 32 :
		break;
	default :
		{
		fclose (pFile);
		
		PRINT_FUNC_LF();
		if( TRUE == OptionsCommandLine.BoolVerboseMode )
			g_print("Seuls ces formats de bitrates : 8 16 24 et 32 sont pris en charge pour la lecture\n"
				"Format de bitrate [ %d ] non prit en charge\n", 
				WaveHeader.FMT.BitsPerSample);
			
		// DEL ALLOC MEMORY
		if (NULL != VarSplit.Tab) {
			g_free (VarSplit.Tab);	VarSplit.Tab = NULL;
		}
		return FALSE;
		}
	}
	VarSplit.nTotalChunckSize = WaveHeader.DATA.Subchunk2Size;
	found = TRUE;
		
	// DEL ALLOC MEMORY
	if (NULL != VarSplit.Tab) {
		g_free (VarSplit.Tab);	VarSplit.Tab = NULL;
	}

	
	if (found == TRUE) {
			
		VarSplit.TotalAllocation = sizeof(POINTS_FILE) * ((WaveHeader.DATA.Subchunk2Size / BLOCK_SIZE) +10);
		VarSplit.Tab = (POINTS_FILE *)g_malloc0 (VarSplit.TotalAllocation + 10);
		
		points = 0;
		if (WaveHeader.FMT.BitsPerSample <= 0) WaveHeader.FMT.BitsPerSample = 8;

		// TRAITEMENT UNIQUES: 8, 16, 24 et 32 bits
		switch (WaveHeader.FMT.BitsPerSample) {
			case 8 :
			case 16 :
			case 24 :
			case 32 :
				// PRE - CALCUL

				ChannelNext = (WaveHeader.FMT.NumChannels -1) * (WaveHeader.FMT.BitsPerSample / 8);

				// LECTURE DES DATAS
				// #define BLOCK_SIZE	2352
				//
				while ((Ret = fread (devbuf, 1, BLOCK_SIZE, pFile)) > 0) {

					min = max = 0;

					for (Indice = 0; Indice < Ret; Indice++) {

						if (WaveHeader.FMT.BitsPerSample == 8) {
							
							tmp = devbuf [ Indice ];
							tmp -= 128;
						}
						else if (WaveHeader.FMT.BitsPerSample == 16) {
							
							tmp = (gchar)devbuf [ Indice +1 ] << 8 | (gchar)devbuf [ Indice ];
							Indice ++;
						}
						else if (WaveHeader.FMT.BitsPerSample == 24) {
							
							tmp  = (gchar)devbuf [ Indice +0 ] >> 16;
							tmp += (gchar)devbuf [ Indice +1 ] >> 8;
							tmp += (gchar)devbuf [ Indice +2 ];
														
							Indice += 2;
						}
						else if (WaveHeader.FMT.BitsPerSample == 32) {
							
							tmp  = (gchar)devbuf [ Indice +0 ] >> 24;
							tmp += (gchar)devbuf [ Indice +1 ] >> 16;
							tmp += (gchar)devbuf [ Indice +2 ] >> 8;
							tmp += (gchar)devbuf [ Indice +3 ];
							
							Indice += 2;
						}
						
						if (tmp > max) {
							
							max = tmp;
						} else if (tmp <= min) {
							
							min = tmp;
						}

						// skip over any extra channels
						Indice += ChannelNext;
					}
					VarSplit.Tab [ points ].Min = min;
					VarSplit.Tab [ points ].Max = max;
					
					points ++;
				}
				break;
			default :
				PRINT("Ne doit pas arriver ici  !!!!");
				if( TRUE == OptionsCommandLine.BoolVerboseMode )
					g_print ("Ce format n'est pas pris en charge : %d\n", WaveHeader.FMT.BitsPerSample);
				fclose (pFile);
				return FALSE;
		}
	}
	fclose (pFile);
	
	VarSplit.MaxPointsInTab = points;
	
	// ALL DATAS
	// points * BLOCK_SIZE
	/*g_print( "points(%d) * BLOCK_SIZE(%d) = \n\t%d octets\n\t%d Ko\n\t%d Mo\n\n",
					points, 
					BLOCK_SIZE, 
					points * BLOCK_SIZE,
					(points * BLOCK_SIZE) / 1024, 
					((points * BLOCK_SIZE) / 1024) / 1024
					 );*/
	
	
	// TODO: MARQUAGE DES PASSAGES BLANC SOIT < ~-50 dB
	for (Indice = 0; Indice < points; Indice ++) {
		if (VarSplit.Tab [ Indice ].Min >= -1. && VarSplit.Tab [ Indice ].Max <= 1.) {
			VarSplit.Tab [ Indice ].Min =
				VarSplit.Tab [ Indice ].Max = 0.0;
		}
	}
	
	VarSplit.Tags = tagswav_remove_info (VarSplit.Tags);
	VarSplit.Tags = (INFO_WAV *)tagswav_get_info (PathNameFile);
	
	// RECHEFCHE DES PLAGES SELON L IDEE DE @Dzef  ;-)
	SplitSpectre_search_blank_pass ();

	VarSplit.BoolReadFileSpectre = TRUE;
	VarSplit.TypeFileIs = TypeFileIs;

	return (TRUE);
}
// TODO
// AFFICHAGE DU SPECTRE
// RAPIDITE DE REAFFICHAGE DE L'AMPLITUDE ACCRUE AVEC LES FONCTIONS gdk_draw_ (...)
// 13 juillet 2009
// 12 mars 2010
// 
void SplitSpectre_draw_lines (void)
{
	GdkColor		gdk_color;
	GdkColormap		*colormap;
	GdkGC			*gc;
	gint			y_min;
	gint			y_max;
	gint			xaxis;
	gint			scale;
	gint			points = 0;
	gint			k;
	gdouble			Percent;
	gint			AdjValue;
	gint			begin = 0;
	gint			end = 0;
	gint			save_begin = 0;
	gboolean		BoolAllocateMemory = FALSE;
	gint			SelBegin = 0;
	gint			SelEnd = 0;
	gint			Len;
	GdkPoint		poly [ 10 ];
	gdouble			SpectreGetWith;
	// static gint		Nbr = 0;
	
	// PRINT_FUNC_LF();
	
	// WAV if bitrate == 8 16 24 32
	if (VarSplit.Tab != NULL && VarSplit.TypeFileIs == FILE_IS_WAV && VarSplit.MaxPointsInTab > 0) {
		
		// PRINT_FUNC_LF();
		// g_print( "\tNbr = %d\n", Nbr++ );
		
		// OPEN DRAW
		colormap = gdk_window_get_colormap (VarSplit.AdrWidgetSpectre->window);
		gc = gdk_gc_new (VarSplit.AdrWidgetSpectre->window);
	
		// 
		// NE PAS REALLOUER A CHAQUE FOIS !!!
		// 
		if (NULL == VarSplit.MaxScale_0) {
			BoolAllocateMemory = TRUE;
		}
		if (VarSplit.TotalAllocationTabScreen < (sizeof(GdkPoint) * (VARSPLIT_SPECTRE_WITH + 20))) {
			BoolAllocateMemory = TRUE;
		}
		if (TRUE == BoolAllocateMemory) {
			
			SplitSpectre_remove_draw ();

			VarSplit.TotalAllocationTabScreen = sizeof(GdkPoint) * (VARSPLIT_SPECTRE_WITH + 20);
			
			VarSplit.MaxScale_0 = (GdkPoint *)g_malloc0 (VarSplit.TotalAllocationTabScreen);
			VarSplit.MinScale_0 = (GdkPoint *)g_malloc0 (VarSplit.TotalAllocationTabScreen);
			VarSplit.MaxScale_1 = (GdkPoint *)g_malloc0 (VarSplit.TotalAllocationTabScreen);
			VarSplit.MinScale_1 = (GdkPoint *)g_malloc0 (VarSplit.TotalAllocationTabScreen);
			VarSplit.MaxScale_2 = (GdkPoint *)g_malloc0 (VarSplit.TotalAllocationTabScreen);
			VarSplit.MinScale_2 = (GdkPoint *)g_malloc0 (VarSplit.TotalAllocationTabScreen);
		}
		
		// LA LIGNE MEDIANE DU GRAPHE
		// xaxis = HAUTEUR_WIDGET / 2;
		xaxis = (VARSPLIT_SPECTRE_H) / 2;

		if (xaxis != 0) {
			if (VarSplit.nBitsPerSample == 16)
				scale = SHRT_MAX  / (xaxis -1);
			else	scale = UCHAR_MAX / (xaxis -1);
			if (scale == 0) {
				scale = 1;
			}
		} else {
			scale = 1;
		}
		
		// 
		begin      = 
		save_begin =
		AdjValue   = (gint)VarSplit.AdjScroll->value;
		Len        = 
		end        = begin + VARSPLIT_SPECTRE_WITH;

		// PRE - CALCUL
		// 4.0.8~beta1
		// Fri, 22 Apr 2011 15:03:02 +0200
		SpectreGetWith = SplitSpectre_get_with();
		
		// Thu, 23 Sep 2010 21:32:41 +0200
		for( points = 0; begin < end; begin ++, points ++ ) {
			
			Percent = ( (gdouble)begin / SpectreGetWith ) * 100.;
			k = ( Percent * (gdouble)VarSplit.MaxPointsInTab ) / 100.;
			
			y_max = xaxis - VarSplit.Tab[ k ].Max / scale;
			y_min = xaxis + fabs( VarSplit.Tab[ k ].Min ) / scale;
			
			// shade = 0;
			VarSplit.MaxScale_0 [ points ] . x = begin;
			VarSplit.MaxScale_0 [ points ] . y = y_max - (y_max - xaxis) * 0 / SAMPLE_SHADES;
			VarSplit.MinScale_0 [ points ] . x = begin;
			VarSplit.MinScale_0 [ points ] . y = y_min + (xaxis - y_min) * 0 / SAMPLE_SHADES;

			// shade = 1;
			VarSplit.MaxScale_1 [ points ] . x = begin;
			VarSplit.MaxScale_1 [ points ] . y = y_max - (y_max - xaxis) * 1 / SAMPLE_SHADES;
			VarSplit.MinScale_1 [ points ] . x = begin;
			VarSplit.MinScale_1 [ points ] . y = y_min + (xaxis - y_min) * 1 / SAMPLE_SHADES;

			// shade = 2;
			VarSplit.MaxScale_2 [ points ] . x = begin;
			VarSplit.MaxScale_2 [ points ] . y = y_max - (y_max - xaxis) * 2 / SAMPLE_SHADES;
			VarSplit.MinScale_2 [ points ] . x = begin;
			VarSplit.MinScale_2 [ points ] . y = y_min + (xaxis - y_min) * 2 / SAMPLE_SHADES;
			
			// RECTIF HAUT
			if (VarSplit.MaxScale_0 [ points ] . y < VARSPLIT_SPECTRE_Y) {
				VarSplit.MaxScale_0 [ points ] . y = VARSPLIT_SPECTRE_Y;
			}
			// RECTIF BAS
			if (VarSplit.MinScale_0 [ points ] . y > VARSPLIT_SPECTRE_H) {
				VarSplit.MinScale_0 [ points ] . y = VARSPLIT_SPECTRE_H -1;
			}
			
			// RECTIF HAUT
			if (VarSplit.MaxScale_1 [ points ] . y < VARSPLIT_SPECTRE_Y) {
				VarSplit.MaxScale_1 [ points ] . y = VARSPLIT_SPECTRE_Y;
			}
			// RECTIF BAS
			if (VarSplit.MinScale_1 [ points ] . y > VARSPLIT_SPECTRE_H) {
				VarSplit.MinScale_1 [ points ] . y = VARSPLIT_SPECTRE_H -1;
			}
			
			// RECTIF HAUT
			if (VarSplit.MaxScale_2 [ points ] . y < VARSPLIT_SPECTRE_Y) {
				VarSplit.MaxScale_2 [ points ] . y = VARSPLIT_SPECTRE_Y;
			}
			// RECTIF BAS
			if (VarSplit.MinScale_2 [ points ] . y > VARSPLIT_SPECTRE_H) {
				VarSplit.MinScale_2 [ points ] . y = VARSPLIT_SPECTRE_H -1;
			}
		}
		
		// (CLEAR) NETTOYER LA SURFACE
		poly [ 0 ] . x = VARSPLIT_SPECTRE_X;
		poly [ 0 ] . y = VARSPLIT_SPECTRE_Y;
		poly [ 1 ] . x = VARSPLIT_SPECTRE_X + VARSPLIT_SPECTRE_W +1;
		poly [ 1 ] . y = VARSPLIT_SPECTRE_Y;
		poly [ 2 ] . x = VARSPLIT_SPECTRE_X + VARSPLIT_SPECTRE_W +1;
		poly [ 2 ] . y = VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H +1;
		poly [ 3 ] . x = VARSPLIT_SPECTRE_X;
		poly [ 3 ] . y = VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H +1;
		poly [ 4 ] . x = VARSPLIT_SPECTRE_X;
		poly [ 4 ] . y = VARSPLIT_SPECTRE_Y;
		CRAYON_BLANC
		gdk_draw_polygon (
			VarSplit.AdrWidgetSpectre->window,
			gc,
			TRUE,
			poly,
			4
			);
		
		SelBegin = SplitSelector_get_pos_begin (VarSplit.SelecteurActif);
		SelEnd   = SplitSelector_get_pos_end (VarSplit.SelecteurActif);
		begin    = save_begin;
				
		for (points = 0; begin < end; begin ++, points ++) { 		
			
			// MaxScale_0
			if (begin >= SelBegin &&  begin <= SelEnd) {
				CRAYON_BLEU		// LA SELECTION
			} else {
				CRAYON_NOIR		// LA NON SELECTION
			}
			gdk_draw_line (VarSplit.AdrWidgetSpectre->window,
					gc,
					points,
					VarSplit.MaxScale_0 [ points ] . y,
					points,
					VarSplit.MinScale_0 [ points ] . y
					);
			
			// MaxScale_1
			if (begin >= SelBegin &&  begin <= SelEnd) {
				CRAYON_BLEU_CLAIR	// LA SELECTION
			} else {
				CRAYON_GRIS		// LA NON SELECTION
			}
			gdk_draw_line (VarSplit.AdrWidgetSpectre->window,
					gc,
					points,
					VarSplit.MaxScale_1 [ points ] . y,
					points,
					VarSplit.MinScale_1 [ points ] . y
					);
			
			// MaxScale_2
			if (begin >= SelBegin &&  begin <= SelEnd) {
				CRAYON_BLEU_CLAIR_PLUS	// LA SELECTION
			} else {
				CRAYON_GRIS_CLAIR	// LA NON SELECTION
			}
			gdk_draw_line (VarSplit.AdrWidgetSpectre->window,
					gc,
					points,
					VarSplit.MaxScale_2 [ points ] . y,
					points,
					VarSplit.MinScale_2 [ points ] . y
					);
		}
				
		// AFFICHE CURSEUR DEBUT
		if (SelBegin >= save_begin && SelBegin < Len) {
			CRAYON_ORANGE
			gdk_draw_line (
				VarSplit.AdrWidgetSpectre->window,
				gc,
				SelBegin  -save_begin,
				VARSPLIT_SPECTRE_Y,
				SelBegin - save_begin,
				VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H
				);
		}
		
		// AFFICHE CURSEUR FIN
		if (VarSplit.SelecteurActif == VarSplit.NbrSelecteurs -1) SelEnd --;
		if (SelEnd >= save_begin && SelEnd < Len) {
			CRAYON_VERT
			gdk_draw_line (
				VarSplit.AdrWidgetSpectre->window,
				gc,
				SelEnd - save_begin,
				VARSPLIT_SPECTRE_Y,
				SelEnd - save_begin,
				VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H
				);
		}
		
		// AFFICHE LE CURSEUR AUDIO
		if (VarSplit.PercentActivePlay >= 0.0) {
			MarkerOld = (gint)(((gdouble)SplitSpectre_get_with() * VarSplit.PercentActivePlay) / 100.0);
			if (MarkerOld >= save_begin && MarkerOld < Len) {
				CRAYON_ROUGE
				gdk_draw_line (
					VarSplit.AdrWidgetSpectre->window,
					gc,
					MarkerOld - save_begin,
					VARSPLIT_SPECTRE_Y,
					MarkerOld - save_begin,
					VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H -2
					);
				gdk_draw_rectangle (
					VarSplit.AdrWidgetSpectre->window,
					gc,
					TRUE,
					MarkerOld - save_begin -6,
					VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H -12,
					14,
					12
					);
			}
		}
		
		// CLOSE DRAW
		gdk_gc_destroy (gc);
	}
}
// AFFICHAGE DU CURSEUR EN MODE PLAY: GAIN DE TEMPS POUR LE CPU
//
void SplitSpectre_draw_lines_play( void )
{
	GdkColor		gdk_color;
	GdkColormap		*colormap;
	GdkGC			*gc;
	gint			points = 0;
	gint			AdjValue;
	gint			begin = 0;
	gint			end = 0;
	gint			save_begin = 0;
	gint			SelBegin = 0;
	gint			SelEnd = 0;
	gint			Len;
	gint			Marker;
	
	// WAV if bitrate == 8 16 24 32
	if (VarSplit.Tab != NULL && VarSplit.TypeFileIs == FILE_IS_WAV && VarSplit.MaxPointsInTab > 0) {
			
		// PRINT_FUNC_LF();
		
		// OPEN DRAW
		colormap = gdk_window_get_colormap (VarSplit.AdrWidgetSpectre->window);
		gc = gdk_gc_new (VarSplit.AdrWidgetSpectre->window);
			
		// 
		begin      = 
		save_begin =
		AdjValue   = (gint)VarSplit.AdjScroll->value;
		Len        = 
		end        = begin + VARSPLIT_SPECTRE_WITH;
		
		Marker   = (gint)(((gdouble)SplitSpectre_get_with() * VarSplit.PercentActivePlay) / 100.0);
		SelBegin = SplitSelector_get_pos_begin (VarSplit.SelecteurActif);
		SelEnd   = SplitSelector_get_pos_end (VarSplit.SelecteurActif);
		begin    = save_begin;
		
		if( -1 == MarkerOld )
			MarkerOld = ( Marker - 20 );
		else	MarkerOld -= 20;

		for (points = 0; begin < end; begin ++, points ++) { 
			
			if( begin < MarkerOld || begin > Marker +20 ) {
				continue;
			}
			
			CRAYON_BLANC
			gdk_draw_line (VarSplit.AdrWidgetSpectre->window,
					gc,
					points,
					VARSPLIT_SPECTRE_Y,
					points,
					VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H +1
					);
			
			// MaxScale_0
			if (begin >= SelBegin &&  begin <= SelEnd) {
				CRAYON_BLEU		// LA SELECTION
			} else {
				CRAYON_NOIR		// LA NON SELECTION
			}
			gdk_draw_line (VarSplit.AdrWidgetSpectre->window,
					gc,
					points,
					VarSplit.MaxScale_0 [ points ] . y,
					points,
					VarSplit.MinScale_0 [ points ] . y
					);
			
			// MaxScale_1
			if (begin >= SelBegin &&  begin <= SelEnd) {
				CRAYON_BLEU_CLAIR	// LA SELECTION
			} else {
				CRAYON_GRIS		// LA NON SELECTION
			}
			gdk_draw_line (VarSplit.AdrWidgetSpectre->window,
					gc,
					points,
					VarSplit.MaxScale_1 [ points ] . y,
					points,
					VarSplit.MinScale_1 [ points ] . y
					);
			
			// MaxScale_2
			if (begin >= SelBegin &&  begin <= SelEnd) {
				CRAYON_BLEU_CLAIR_PLUS	// LA SELECTION
			} else {
				CRAYON_GRIS_CLAIR	// LA NON SELECTION
			}
			gdk_draw_line (VarSplit.AdrWidgetSpectre->window,
					gc,
					points,
					VarSplit.MaxScale_2 [ points ] . y,
					points,
					VarSplit.MinScale_2 [ points ] . y
					);
		}
				
		// AFFICHE CURSEUR DEBUT
		if (SelBegin >= save_begin && SelBegin < Len) {
			CRAYON_ORANGE
			gdk_draw_line (
				VarSplit.AdrWidgetSpectre->window,
				gc,
				SelBegin  -save_begin,
				VARSPLIT_SPECTRE_Y,
				SelBegin - save_begin,
				VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H
				);
		}
		
		// AFFICHE CURSEUR FIN
		if (VarSplit.SelecteurActif == VarSplit.NbrSelecteurs -1) SelEnd --;
		if (SelEnd >= save_begin && SelEnd < Len) {
			CRAYON_VERT
			gdk_draw_line (
				VarSplit.AdrWidgetSpectre->window,
				gc,
				SelEnd - save_begin,
				VARSPLIT_SPECTRE_Y,
				SelEnd - save_begin,
				VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H
				);
		}
		
		// AFFICHE LE CURSEUR AUDIO
		if (VarSplit.PercentActivePlay >= 0.0) {
			if (Marker >= save_begin && Marker < Len) {
				CRAYON_ROUGE
				gdk_draw_line (
					VarSplit.AdrWidgetSpectre->window,
					gc,
					Marker - save_begin,
					VARSPLIT_SPECTRE_Y,
					Marker - save_begin,
					VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H -2
					);
				gdk_draw_rectangle (
					VarSplit.AdrWidgetSpectre->window,
					gc,
					TRUE,
					Marker - save_begin -6,
					VARSPLIT_SPECTRE_Y + VARSPLIT_SPECTRE_H -12,
					14,
					12
					);
			}
		}
		
		// CLOSE DRAW
		gdk_gc_destroy (gc);

		MarkerOld = Marker;
	}
}





















